#!/usr/bin/env python
# -*- coding: utf-8 -*-

import os
import sys

from common import T8
from jinja2 import Template, Environment, FileSystemLoader

SCRIPT_DIR = os.path.dirname(os.path.realpath(__file__))

TEMPLATE_SIMPLE = """
#!/usr/bin/env ruby
# -*- coding: utf-8 -*-

#########################
# Generated by Templ8er #
#########################

{% for package in packages %}
require '{{ package }}'
{% endfor %}

def main()
    # Your codes here
    puts 'Your codes here.'
end

if __FILE__ == $0
	main()
end
"""

class T8Ruby(T8):
    def simple_ruby_script(self, name, file_packages):
        if file_packages is not None:
            with open(os.path.join(self.target_dir, file_packages), 'r') as f:
                packages = [ l.strip() for l in f.readlines()]
        else:
            packages = []
        target_file = os.path.join(self.target_dir, '%s.rb' % name)
        with open(target_file, 'w') as f:
            f.write(Environment().from_string(TEMPLATE_SIMPLE).render(packages=packages).strip())
        print 'New script %s generated.' % str(target_file)
